

DEFINE VARIABLE cClientCmd AS CHARACTER NO-UNDO.

{clib.i}

REPEAT:

  RUN PutClient ("100 Ready").
  ASSIGN cClientCmd = "".
  RUN GetClient (OUTPUT cClientCmd).

  RUN PutClient ("101 Action Received: " + cClientCmd).

  /*******************************************************/
  /* We use begins in case command has arguments         */
  /*******************************************************/

  IF cClientCmd BEGINS "STOP" THEN LEAVE.

  IF cClientCmd BEGINS "TIME" THEN RUN HandleTime.

  IF cClientCmd BEGINS "env" THEN RUN HandleEnv.

  IF cClientCmd BEGINS "CMD" THEN RUN HandleCmd (cClientCmd).
  
END. /* REPEAT */

RUN PutClient ("110 Bye").

QUIT.

/************************ Command Handlers **********************/
PROCEDURE HandleTime:

  RUN PutClient ( STRING (TIME, "HH:MM:SS")).

END.

PROCEDURE HandleEnv:

  DEFINE VARIABLE cLine AS CHARACTER NO-UNDO.

  INPUT THROUGH set.

  REPEAT:

    IMPORT UNFORMATTED cLine.
    RUN PutClient (cLine).

  END.

  INPUT CLOSE.

END. /* PROCEDURE HandleEnv */

PROCEDURE HandleCmd:

  DEFINE INPUT PARAMETER cClientCmd AS CHARACTER NO-UNDO.

  DEFINE VARIABLE cCmd AS CHARACTER NO-UNDO.
  DEFINE VARIABLE cLine AS CHARACTER NO-UNDO.

  ASSIGN cCmd = SUBSTRING(cClientCmd, 4, LENGTH(cClientCmd)).

  INPUT THROUGH VALUE(cCmd).

  REPEAT:

    IMPORT UNFORMATTED cLine.
    RUN PutClient (cLine).

  END.

  INPUT CLOSE.

END. /* PROCEDURE HandleCmd */

